
module AN_Hoshino_TOOL
    module AN_Height_Datum
	    class HeightTool_Datum

            def activate					#呼籲工具的第一次激活 - 在這裡初始化(Calls on the tool first activation - initialized here)
			 @ip = Sketchup::InputPoint.new  
			 @iptemp = Sketchup::InputPoint.new
			 @displayed = false
			 @pt=nil
			 @txtaa =nil
			 @vec_t=nil
			 @datum_a=nil
			 txtaa     = Sketchup.read_default('heighttool', 'txtaa')
			 vec_t    = Sketchup.read_default('heighttool', 'vec_t')
			 @txtaa    = txtaa.to_s  unless txtaa    ==nil
			 @vec_t   = vec_t.to_l  unless vec_t   ==nil
			 @txtaa    =Strings.GetString("Height")     if not @txtaa  #--------------------------------預先定義前綴 "高度" (Predefined prefix "height")
			 @vec_t   =2          if not @vec_t #--------------------------------預先定義標柱長度 1.0(Predefined standard column length 1.0)
			 @txt=@txtaa
			 @ctrlif=1
			 @ctrl_txt=Strings.GetString("draw(ON)")
			 @vec=@vec_t,@vec_t,@vec_t
			 @datum=Sketchup.active_model.get_attribute(Strings.GetString("Height_Datum"),"z",0.0.m)
			 Sketchup.active_model.set_attribute(Strings.GetString("Height_Datum"),"z",@datum)
			 Sketchup::set_status_text(Strings.GetString("on R Button Down")+"，Ctrl("+@ctrl_txt+")，"+Strings.GetString("Height_Datum")+" = "+@datum.to_l.to_s, SB_PROMPT)
			end#activate

            #________________________________________________________________增加鎖點(Increase Snap)
			def draw(view)
  			 if @ctrlif==1
			     if( @ip.valid? && @ip.display? )
				     @ip.draw(view)
					end
				end
			end	#draw
			
			def onMouseMove(flags, x, y, view) #鼠標在移動(on Mouse Move)
			 Sketchup::set_status_text(Strings.GetString("on R Button Down")+"，Ctrl("+@ctrl_txt+")，"+Strings.GetString("Height_Datum")+" = "+@datum.to_l.to_s, SB_PROMPT)
			 datum=@datum.to_l
			 @iptemp.pick view, x, y		   #得到模型中的位置(Give the model position)
			 if( @iptemp.valid? )
			     changed = @iptemp != @ip
				 @ip.copy! @iptemp
				 pos = @ip.position;
				 @pt=pos				      
				 msg = @ip.tooltip 			
				 if( msg.length > 0 )
				     msg << ""
				 end
				 msg << @txtaa
				 msg << (pos.z+datum).to_l.to_s
				 view.tooltip = msg	
				 if( changed and (@ip.display? or @displayed) )         
				   view.invalidate			
			     end
				end
			end
			
			def onLButtonUp(flags, x, y, view)	#當鼠標左鍵發布(When the mouse button release)
 			 datum=@datum.to_l
			 z=(@pt.z+datum).to_l
			 @txt=Strings.GetString("Height")
			 @txt<<z.to_s
			 Sketchup::set_status_text(Strings.GetString("Height_Datum")+" = "+@datum.to_l.to_s, SB_PROMPT)
			 model=Sketchup.active_model
			 model.start_operation (Strings.GetString("Height_Datum"))#--------------------模型操作開始(Model operation starts)
			 e=model.active_entities
			 t=e.add_text @txt,@pt,@vec
			 t.point=@pt
			 t.display_leader=true
			 t.leader_type=1
			 t.arrow_type=2
			 t.set_text(@txtaa+(t.point.z+datum).to_l.to_s.gsub(/~ /,""))
			 model.commit_operation#------------------------------------模型操作結束(End Model Operations)
			end
			
			def onRButtonDown(flags, x, y, view)#========================================滑鼠右鍵(onRButtonDown)
			 @datum=Sketchup.active_model.get_attribute(Strings.GetString("Height_Datum"),"z",0.0.m)
			 datum=@datum
			 prompts   = [Strings.GetString("Prefix:"), Strings.GetString("Marked shift:"), Strings.GetString("Height_Datum 'Z'")]#Prefix 前綴： Marked shift 標註偏移： Height_Datum 'Z' 基準點 'Z':
			 values = [@txtaa  , @vec_t.to_l, datum]           #
			 results = inputbox(prompts, values, Strings.GetString("Height_Datum Setting"))#Height_Datum Setting
			 return nil unless results#
			 @txtaa, @vec_t, @datum = results#
			 txtaa, vec_t=@txtaa, @vec_t
			 unless @vec_t>=0
 			     UI.beep
				 return nil
				end
			 Sketchup.write_default('heighttool', 'txtaa',  txtaa)              
			 Sketchup.write_default('heighttool', 'vec_t', "#{vec_t.to_l}")    
			 @vec=@vec_t,@vec_t,@vec_t
			 Sketchup.active_model.set_attribute(Strings.GetString("Height_Datum"),"z",@datum)
			end#=========================================================================(滑鼠右鍵)結束(onRButtonDown_end)

			def onKeyDown(key, repeat, flags, view)#----------------Ctrl鍵(KEY)
			 case key
			    when COPY_MODIFIER_KEY then
			      if @ctrlif==1
			         @ctrl_txt=Strings.GetString("draw(OFF)")
				     @ctrlif=2
				    elsif @ctrlif==2
				     @ctrlif=1
				     @ctrl_txt=Strings.GetString("draw(ON)")
				    end
				end
			end
		end	#HeightTool_Datum
    #####################################################
	    if( not $Height_Tool_loaded )		# Add HeightTool to the plugins menu once only
	        plugin_menu = UI.menu("Plugins").add_item(Strings.GetString("Height_Datum")) { 
		    Sketchup.active_model.select_tool AN_Height_Datum::HeightTool_Datum.new }
		    $Height_Tool_loaded = true
	    end
	end#AN_Height_Datum

end #AN_Hoshino_TOOL
